SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: 'HaoWu 2/17/2014 15:05' prior: 0!
A LOCell is a cell in the game which will be blue or yellow.

Instance Variables
	mouseAction:		<Object>

mouseAction
	- xxxxx
!

!LOCell methodsFor: 'initialization' stamp: 'HaoWu 2/17/2014 15:09'!
initialize
	super initialize .
	self label: '' .
	self borderWidth: 2 .
	bounds := 0@0 corner: 16@16 .
	offColor := Color paleYellow .
	onColor := Color paleBlue darker .
	self useSquareCorners .
	self turnOff .
	! !

!LOCell methodsFor: 'accessing' stamp: 'HaoWu 2/17/2014 15:45'!
mouseAction: aBlock
	mouseAction := aBlock .! !

!LOCell methodsFor: 'event handling' stamp: 'HaoWu 2/17/2014 15:46'!
mouseUp: anEvent
	mouseAction value .! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'HaoWu 2/21/2014 22:03'!
reset 
	self turnOff .! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'as yet unclassified' stamp: 'HaoWu 2/17/2014 15:33'!
cellsPerSide
	"The number of cells along each side of the game"
	^10! !

!LOGame methodsFor: 'initialization' stamp: 'HaoWu 2/17/2014 15:28'!
initialize 
	| sampleCell width height n |
	super initialize .
	n := self cellsPerSide .
	sampleCell := LOCell new .
	width := sampleCell width .
	height := sampleCell height .
	self bounds: (5@5 extent: (width * n) @ (height * n ) + (2 * self borderWidth)) .
	cells := Matrix new: n tabulate: [:i :j | self newCellAt:i at: j]! !

!LOGame methodsFor: 'event handling' stamp: 'HaoWu 2/17/2014 15:56'!
mouseMove: anEvent
	! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'HaoWu 2/17/2014 15:52'!
newCellAt: i at: j 
	"Create a cell for position (i,j) and add it to my on-screen
	representation at the appropriate screen position. Answer the new cell"
	|c origin|
	c := LOCell new .
	origin := self innerBounds origin .
	self addMorph: c .
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin .
	c mouseAction: [self toggleNeighboursOfCellAt:i at:j] .
	^c .! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'HaoWu 2/21/2014 21:59'!
reset 
	cells do: [:cell | cell reset  ]! !

!LOGame methodsFor: 'game logic' stamp: 'HaoWu 2/17/2014 15:42'!
toggleNeighboursOfCellAt: i at: j 
	(i > 1) ifTrue: [ (cells at: i-1 at:j) toggleState].
	(i < self cellsPerSide ) ifTrue:  [ (cells at: i+1 at:j) toggleState] .
	(j > 1) ifTrue: [(cells at: i at: j-1) toggleState].
	(j < self cellsPerSide ) ifTrue: [(cells at:i at: j+1) toggleState].! !
